/**
 * Generated by Apache Royale Compiler from org/apache/royale/reflection/getQualifiedSuperclassName.as
 * org.apache.royale.reflection.getQualifiedSuperclassName
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.reflection.getQualifiedSuperclassName');

goog.require('org.apache.royale.reflection.ExtraData');
goog.require('org.apache.royale.utils.Language');



/**
 *  The equivalent of flash.utils.getQualifiedSuperclassName,
 *  except that qualified names do not include '::' between the package naming sequence and the definition name.
 *  The '.' is always used to separate parts of the qualified name.
 *  An example would be "my.package.path.MyClassName"
 * 
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion Royale 0.0
 * @param {*} value
 * @return {string}
 */
org.apache.royale.reflection.getQualifiedSuperclassName = function(value) {
  
  if (value === null || typeof(value) === 'undefined')
    return null;
  var /** @type {Object} */ constructorAsObject = org.apache.royale.utils.Language.is(value, org.apache.royale.utils.Language.synthType('Class')) ? value : value["constructor"];
  var /** @type {Object} */ superRef = constructorAsObject.superClass_;
  if (!superRef && org.apache.royale.reflection.ExtraData.hasData(constructorAsObject)) {
    if (constructorAsObject == Function && value.prototype == undefined) {
      superRef = org.apache.royale.reflection.ExtraData.getData(Function);
    } else {
      superRef = org.apache.royale.reflection.ExtraData.getData(constructorAsObject)['NATIVE_BASE'];
      if (superRef) {
        superRef = org.apache.royale.reflection.ExtraData.getData(superRef);
      }
    }
    if (superRef) {
      superRef = superRef['ROYALE_CLASS_INFO'];
    }
  } else {
    if (superRef == null)
      return null;
    superRef = superRef.ROYALE_CLASS_INFO;
  }
  return org.apache.royale.utils.Language.string(superRef ? superRef.names[0].qName : null);
}